CONST
  CMOS_Addr = $70 ;
  CMOS_DATA = $71 ;

FUNCTION CMOS_GetByte(nr : BYTE) : BYTE ;
BEGIN
  PORT[CMOS_Addr]:=Nr ;
  CMOS_GetByte:=PORT[CMOS_DATA] ;
END ;

PROCEDURE CMOS_SetByte(nr,val : BYTE) ;
BEGIN
  PORT[CMOS_Addr]:=Nr ;
  PORT[CMOS_DATA]:=val ;
END ;

FUNCTION TestVM86 : BOOLEAN ;           { Ist Windows o.. aktiv ? }
VAR OK : BYTE ;
BEGIN
  ASM
    MOV AX,$FFFF
    DB $0F          { BEGIN of }
    DB $01
    DB $E0          { SMSW AX }
    MOV OK,AL
  END ;
  IF OK AND $1 = 1 THEN BEGIN
    TestVM86:=TRUE ;
  END ELSE TestVM86:=FALSE ;
END ;

FUNCTION Check386 : BOOLEAN ;           { Ist CPU 386 oder hher ? }
VAR ok : BYTE ;
BEGIN
  ASM
    pushf
    xor ah,ah
    push ax
    popf
    pushf
    pop ax
    and ah,0f0h
    cmp ah,0f0h
    je @detectno386
    mov ah,0f0h
    push ax
    popf
    pushf
    pop ax
    and ah,0f0h
    mov Ok,AH
    JMP @raus
    @detectno386:
      XOR AH,AH
    @raus:
  END ;
  IF OK=0 THEN BEGIN
    Check386:=FALSE ;
  END ELSE
    Check386:=TRUE ;
END ;

FUNCTION CheckCPUID : BOOLEAN ;         { Gibt es eine CPUID }
VAR tmp : WORD ;
BEGIN
  ASM
    DB $0F          { BEGIN of }
    DB $20
    DB $C0          { MOV EAX,CR0 }

    PUSH AX
    MOV CL,16
    DB 66h
      SHR AX,CL
    MOV BX,AX
    XOR AX,$20
    DB 66h
      SHL AX,CL
    POP AX
    DB $0F          { BEGIN of }
    DB $22
    DB $C0          { MOV CR0,EAX }
    DB $0F          { BEGIN of }
    DB $20
    DB $C0          { MOV EAX,CR0 }
    MOV DX,0
    DB 66h
      SHR AX,CL
    DB 66h
      CMP AX,BX
    JNZ @OK
      MOV DX,1
    @OK:
    MOV tmp,DX
  END ;
  CheckCPUID:=(tmp=0)
END ;

FUNCTION GetCPUID : STRING ;                    { CPU-Vendorcode }
VAR eax1,eax2,ebx1,ebx2,ecx1,ecx2,edx1,edx2 : WORD ;
BEGIN
  ASM
    DB 66h
      XOR AX,AX
    DB $0F,$A2

    MOV eax1,ax
    DB 66h
      SHR AX,16
    MOV eax2,ax

    MOV ebx1,bx
    DB 66h
      SHR bX,16
    MOV ebx2,bx

    MOV ecx1,cx
    DB 66h
      SHR cX,16
    MOV ecx2,cx

    MOV edx1,dx
    DB 66h
      SHR dX,16
    MOV edx2,dx

  END ;
  GetCPUID:=CHR(ebx1 AND $FF) +
            CHR((ebx1 SHR 8) AND $FF) +
            CHR(ebx2 AND $FF) +
            CHR((ebx2 SHR 8) AND $FF) +
            CHR(edx1 AND $FF) +
            CHR((edx1 SHR 8) AND $FF) +
            CHR(edx2 AND $FF) +
            CHR((edx2 SHR 8) AND $FF) +
            CHR(ecx1 AND $FF) +
            CHR((ecx1 SHR 8) AND $FF) +
            CHR(ecx2 AND $FF) +
            CHR((ecx2 SHR 8) AND $FF) ;

END ;

FUNCTION GetCPUModell : LONGINT ;               { CPU-Steppings }
VAR eax1,eax2,ebx1,ebx2,ecx1,ecx2,edx1,edx2 : WORD ;
BEGIN
  ASM
    DB 66h
      XOR AX,AX
    MOV AX,1

    DB $0F,$A2

    MOV eax1,ax
    DB 66h
      SHR AX,16
    MOV eax2,ax

    MOV ebx1,bx
    DB 66h
      SHR bX,16
    MOV ebx2,bx

    MOV ecx1,cx
    DB 66h
      SHR cX,16
    MOV ecx2,cx

    MOV edx1,dx
    DB 66h
      SHR dX,16
    MOV edx2,dx

  END ;
  GetCPUModell:=eax1 SHR 8 ;
END ;

