VAR
  HD_MEM_Base   : WORD ;
  HD_MEM_Idx    : WORD ;
  HD_ERR        : WORD ;

CONST
  HD_DATA        = $1F0 ;
  HD_Error       = $1F1 ;
  HD_NSector     = $1F2 ;
  HD_Sector      = $1F3 ;
  HD_LCyl        = $1F4 ;
  HD_HCyl        = $1F5 ;
  HD_Current     = $1F6 ;
  HD_STATUS      = $1F7 ;
  HD_Command     = $1F7 ;
  HD_CMD         = $3F6 ;
  HD_SDATA        = $170 ;
  HD_SError       = $171 ;
  HD_SNSector     = $172 ;
  HD_SSector      = $173 ;
  HD_SLCyl        = $174 ;
  HD_SHCyl        = $175 ;
  HD_SCurrent     = $176 ;
  HD_SSTATUS      = $177 ;
  HD_SCommand     = $1F7 ;
  HD_SCMD         = $3F6 ;

  St_ERROR          = $01 ;
  St_Index          = $02 ;
  St_ECC            = $04 ;
  St_DRQ            = $08 ;
  St_Seek           = $10 ;
  St_WRERR          = $20 ;
  St_Ready          = $40 ;
  St_Busy           = $80 ;

TYPE
  tPartEntry            = RECORD
                            Boot        : BYTE ;
                            HeadStart   : BYTE ;
                            CylSekStart : WORD ;
                            Typ         : BYTE ;
                            HeadEnde    : BYTE ;
                            CylSekEnde  : WORD ;
                            RelStart    : LONGINT ;
                            Sizel,SizeH : WORD ;
                          END ;
  tPartSek              = RECORD
                            res1        : ARRAY[0..$1BD] OF BYTE ;
                            entry       : ARRAY[0..3] OF tPartEntry ;
                            IDFlag      : WORD ;
                          END ;

VAR
  TransferBlock         : ARRAY[0..255] OF WORD ;

FUNCTION RDW : WORD ;   { Nehme WORD aus dem Data-Port des HD-Kanals 0 }
VAR tmp : WORD ;
BEGIN
  ASM
    MOV DX,HD_DATA
    IN AX,DX
    MOV tmp,AX
  END ;
  RDW:=tmp ;
END ;

FUNCTION RDWS : WORD ;  { Nehme WORD aus dem Data-Port des HD-Kanals 1 }
VAR tmp : WORD ;
BEGIN
  ASM
    MOV DX,HD_DATA-$80
    IN AX,DX
    MOV tmp,AX
  END ;
  RDWS:=tmp ;
END ;

PROCEDURE Pause ;       { Emuliert kurze Pause - Delay() funktioniert nicht }
VAR i : LONGINT ;
BEGIN
  FOR i:=0 TO 6000 DO ;
END ;

FUNCTION HD_Busy : BOOLEAN ; { primrer Kontroller beschftigt ? }
BEGIN
  HD_Busy:=(PORT[HD_STATUS] AND St_Busy>0) ;
END ;

FUNCTION HD_Ready : BOOLEAN ; { primrer Kontroller bereit ? }
BEGIN
  HD_Ready:=(PORT[HD_STATUS] AND St_Ready>0) ;
END ;

FUNCTION HD_DRQ : BOOLEAN ; { primrer Kontroller aufnahme-/sende-fhig ? }
BEGIN
  HD_DRQ:=(PORT[HD_STATUS] AND St_DRQ>0) ;
END ;

PROCEDURE WaitDRQ ; { Warte bis Daten anliegen (knnen) }
VAR i : WORD ;
BEGIN
  i:=0 ;
  WHILE NOT HD_DRQ AND (i<60000) DO INC(i) ;
  IF i=60000 THEN INC(HD_ERR) ;
END ;

FUNCTION GetHDStatus : BYTE ; { Status Primrer-Kontroller }
BEGIN
  GetHDStatus:=PORT[HD_Status] ;
END ;

PROCEDURE WaitHD ; { Warte auf Bereitschaft des primren Kontrollers }
VAR i : WORD ;
BEGIN
  i:=0 ;
  WHILE HD_Busy AND (i<60000) DO INC(i) ;
  IF i=60000 THEN INC(HD_ERR) ;
END ;

FUNCTION HDS_Busy : BOOLEAN ; { sekundrer Kontroller beschftigt ? }
BEGIN
  HDS_Busy:=(PORT[$177] AND St_Busy>0) ;
END ;

FUNCTION HDS_Ready : BOOLEAN ; { sekundrer Kontroller bereit ? }
VAR i : WORD ;
BEGIN
  HDS_Ready:=(PORT[$177] AND St_Ready>0) ;
  IF i=60000 THEN INC(HD_ERR) ;
END ;

FUNCTION GetHDSStatus : BYTE ; { Status sekundrer Kontroller }
BEGIN
  GetHDSStatus:=PORT[$177] ;
END ;

PROCEDURE WaitHDS ; { Warte auf Bereitschaft des sekundren Kontrollers }
VAR i : WORD ;
BEGIN
  i:=0 ;
  WHILE HDS_Busy AND (i<60000) DO INC(i) ;
  IF i=60000 THEN INC(HD_ERR) ;
END ;

FUNCTION HDS_DRQ : BOOLEAN ; {knnen Daten anliegen ?}
BEGIN
  HDS_DRQ:=(PORT[HD_STATUS-$80] AND St_DRQ>0) ;
END ;

PROCEDURE WaitDRQS ; { Warte bis Daten anliegen (knnen) }
VAR i : WORD ;
BEGIN
  i:=0 ;
  WHILE NOT HDS_DRQ AND (i<60000) DO INC(i) ;
  IF i=60000 THEN INC(HD_ERR) ;
END ;

{ Sende Befehl an Laufwerk (Daten vorbehalten) }
PROCEDURE DoHDCMD(Drive,Head,Sector : BYTE;Cyl : WORD;nSector,CMD : BYTE) ;
BEGIN
  Drive:=Drive AND $03 ;
  IF Drive < 2 THEN BEGIN
    WaitHD ;
    PORT[HD_Current]:=(Drive SHL 4) OR (Head AND $0F) ;
    WaitHD ;
    PORT[HD_Sector]:=Sector ;
    WaitHD ;
    PORT[HD_LCyl]:=Cyl AND $FF ;
    WaitHD ;
    PORT[HD_HCyl]:=Cyl SHR 8 ;
    WaitHD ;
    PORT[HD_NSector]:=NSector ;
    WaitHD ;
    PORT[HD_Command]:=CMD ; ;
  END ELSE BEGIN
    WaitHD ;
    PORT[HD_Current-$80]:=((Drive-2) SHL 4) OR (Head AND $0F) ;
    WaitHD ;
    PORT[HD_Sector-$80]:=Sector ;
    WaitHD ;
    PORT[HD_LCyl-$80]:=Cyl AND $FF ;
    WaitHD ;
    PORT[HD_HCyl-$80]:=Cyl SHR 8 ;
    WaitHD ;
    PORT[HD_NSector-$80]:=NSector ;
    WaitHD ;
    PORT[HD_Command-$80]:=CMD ; ;
  END ;
END ;

{Lese Sektor (primrer Kontroller }
PROCEDURE ReadSector(Drive,Head,Sek,Cyl : WORD) ;
VAR i,val : WORD ;
    v1,v2 : BYTE ;
BEGIN
  ASM
    CLI
  END ;
  DoHDCMD(Drive,Head,Sek,Cyl,1,$20) ;
  IF drive < 2 THEN BEGIN
    WaitHD ;
    WaitDRQ ;
  END ELSE BEGIN
    WaitHDS ;
    WaitDRQS ;
  END ;
  FOR i:=0 TO 255 DO BEGIN
    IF Drive<2 THEN val:=RDW ELSE val:=RDWS ;
    MEM[HD_MEM_Base:HD_Mem_Idx+i*2]:=val AND $FF ;
    MEM[HD_MEM_Base:HD_Mem_Idx+i*2+1]:=val SHR 8 ;
  ASM
    STI
  END ;
  END ;
END ;

