TYPE
  tDrive       = RECORD
                   DriveNr      : BYTE ;
                   Size         : LONGINT ;
                   MaxCyl       : WORD ;
                   MaxSec       : WORD ;
                   MaxHead      : WORD ;
                   DeviceName   : STRING ;
                 END ;

VAR drv0,drv1    : tDrive ;             { IDE 0 slave / master }
    drv2,drv3    : tDrive ;             { IDE 1 slave / master }
    pdrv0,pdrv1  : ^tDrive ;            { Hilfsmittel zum Zugriff }
    pdrv2,pdrv3  : ^tDrive ;

    IDE_Interface : tDRV_Interface ;    { Schnittstelle definieren }

PROCEDURE LocateDrives ;                { Ermittle Daten der prim. Platten }
TYPE
    tchInfo = ARRAY[0..511] OF CHAR ;
VAR info : ARRAY[0..255] OF WORD ;
    chinfo : ^tChInfo ;
    drvinfo: ^tChInfo ;
    i      : WORD ;
BEGIN
  { Ermittle Master-Daten  - primary}
  pDrv0:=PTR(24,Ofs(drv0)) ;
  pDrv1:=PTR(24,Ofs(drv1)) ;
  chInfo:=ADDR(info) ;
  drvinfo:=ADDR(drv0.DeviceName) ;
  drvinfo:=PTR(24,OFS(drvinfo^)) ;
  DoHDCMD(0,1,1,1,1,$EC) ;
  WaitHD ;
  WaitDRQ ;
  FOR i:=0 TO 255 DO
    info[i]:=RDW ;
  drvinfo^[0]:=#0 ;
  IF HD_ERR=0 THEN BEGIN
    drvinfo^[0]:=#38 ;
    FOR i:=1 TO 19 DO BEGIN
      drvinfo^[i*2]:=chinfo^[53+i*2-1] ;
      drvinfo^[i*2-1]:=chinfo^[53+i*2] ;
    END ;
    pdrv0^.DriveNr:=0 ;
    pdrv0^.MaxSec:=info[56] ;
    pdrv0^.MaxCyl:=info[54] ;
    pdrv0^.MaxHead:=info[55] ;
    CreateDRV(0,pdrv0^.MaxHead,pdrv0^.MaxSec,pdrv0^.MaxCyl,PTR(24,OFS(IDE_Interface))) ;
  END ELSE HD_Err:=0 ;
  { Ermittle Slave-Daten  - primary }
  drvinfo:=ADDR(drv1.DeviceName) ;
  drvinfo:=PTR(24,OFS(drvinfo^)) ;
  DoHDCMD(1,1,1,1,1,$EC) ;
  WaitHD ;
  WaitDRQ ;
  drvinfo^[0]:=#0 ;
  FOR i:=0 TO 255 DO
    info[i]:=RDW ;
  IF HD_Err=0 THEN BEGIN
    drvinfo^[0]:=#38 ;
    FOR i:=1 TO 19 DO BEGIN
      drvinfo^[i*2]:=chinfo^[53+i*2-1] ;
      drvinfo^[i*2-1]:=chinfo^[53+i*2] ;
    END ;
    pdrv1^.DriveNr:=1 ;
    pdrv1^.MaxSec:=info[56] ;
    pdrv1^.MaxCyl:=info[54] ;
    pdrv1^.MaxHead:=info[55] ;
    CreateDRV(1,pdrv1^.MaxHead,pdrv1^.MaxSec,pdrv1^.MaxCyl,@IDE_Interface) ;
  END ELSE HD_Err:=0 ;

  { Ermittle Master-Daten  - secondary}
  pDrv2:=PTR(24,Ofs(drv2)) ;
  pDrv3:=PTR(24,Ofs(drv3)) ;
  chInfo:=ADDR(info) ;
  drvinfo:=ADDR(drv2.DeviceName) ;
  drvinfo:=PTR(24,OFS(drvinfo^)) ;
  DoHDCMD(2,1,1,1,1,$EC) ;
  WaitHDs ;
  WaitDRQs ;
  FOR i:=0 TO 255 DO
    info[i]:=RDWS ;
  drvinfo^[0]:=#0 ;
  IF HD_ERR=0 THEN BEGIN
    drvinfo^[0]:=#38 ;
    FOR i:=1 TO 19 DO BEGIN
      drvinfo^[i*2]:=chinfo^[53+i*2-1] ;
      drvinfo^[i*2-1]:=chinfo^[53+i*2] ;
    END ;
    pdrv2^.DriveNr:=2 ;
    pdrv2^.MaxSec:=info[56] ;
    pdrv2^.MaxCyl:=info[54] ;
    pdrv2^.MaxHead:=info[55] ;
    CreateDRV(2,pdrv2^.MaxHead,pdrv2^.MaxSec,pdrv2^.MaxCyl,@IDE_Interface) ;
  END ELSE HD_Err:=0 ;
  { Ermittle Slave-Daten  - secondary }
  drvinfo:=ADDR(drv3.DeviceName) ;
  drvinfo:=PTR(24,OFS(drvinfo^)) ;
  DoHDCMD(3,1,1,1,1,$EC) ;
  WaitHDs ;
  WaitDRQs ;
  drvinfo^[0]:=#0 ;
  FOR i:=0 TO 255 DO
    info[i]:=RDWS ;
  IF HD_Err=0 THEN BEGIN
    drvinfo^[0]:=#38 ;
    FOR i:=1 TO 19 DO BEGIN
      drvinfo^[i*2]:=chinfo^[53+i*2-1] ;
      drvinfo^[i*2-1]:=chinfo^[53+i*2] ;
    END ;
    pdrv3^.DriveNr:=3 ;
    pdrv3^.MaxSec:=info[56] ;
    pdrv3^.MaxCyl:=info[54] ;
    pdrv3^.MaxHead:=info[55] ;
    CreateDRV(3,pdrv3^.MaxHead,pdrv3^.MaxSec,pdrv3^.MaxCyl,@IDE_Interface) ;
  END ELSE HD_Err:=0 ;
END ;

{Lese Absoluten Sektor - basierend auf Laufwerksdaten }
PROCEDURE ReadSectorABS(Drive : TDrive;nrl,nrh : WORD) ;
VAR tc,ts,th : WORD ;
BEGIN
  ASM
    CLI
    MOV AX,nrh
    DB 66h
     SHL AX,16
    MOV AX,nrl
    DB 66h
     XOR BX,BX
    MOV BX,drive.MaxHead
    DB 66h
     DIV BX
    MOV th,DX
    MOV BX,drive.MaxSec
    DB 66h
     DIV BX
    INC DX
    MOV ts,DX
    MOV tc,AX
    DB 66h
     XOR AX,AX
    STI
  END ;
  ReadSector(drive.DriveNr,th,ts,tc) ;
END ;

{ Erstelle Interface-Funktionen }

{$F+}
PROCEDURE IDE_ReadSektor(drive,head,sek,cyl : WORD) ;
BEGIN
  ReadSector(drive,head,sek,cyl) ;
END ;
{$F-}

PROCEDURE CreateIDE_Interface ;
BEGIN
  @IDE_Interface.ReadSektor:=PTR(48,OFS(IDE_ReadSektor)) ;       { ReadSektor aus IDE }
  @IDE_Interface.WriteSektor:=NIL ;                                { Schreibfunktion noch nicht eingearbeitet }
  @IDE_Interface.Reset:=NIL ;                                      { RESET noch nicht ntig }
END ;

