PROCEDURE SetLogicalScreen(nr : WORD) ; FORWARD ;

PROCEDURE DoPICReset ;
BEGIN
  DisableIRQ(1) ;
  EnableIRQ(1) ;
  DisableIRQ(0) ;
  EnableIRQ(0) ;
  PORT[$20]:=$20 ;
  PORT[$A0]:=$20 ;
END ;

PROCEDURE IDTDIVZ ;
BEGIN
  ASM
    MOV DX,24
    MOV DS,DX
    MOV ES,DX
  END ;
  WriteLine(SysScreen,DIVZ) ;
END ;

VAR TimeTicks : WORD ;

PROCEDURE UpdateTime ;
BEGIN
  WriteChar(SysScreen,80,1,CMOS_GetByte(0) AND $0F+48) ;
  WriteChar(SysScreen,79,1,(CMOS_GetByte(0) AND $F0) SHR 4 +48) ;
  WriteChar(SysScreen,78,1,58) ;
  WriteChar(SysScreen,77,1,CMOS_GetByte(2) AND $0F+48) ;
  WriteChar(SysScreen,76,1,(CMOS_GetByte(2) AND $F0) SHR 4 +48) ;
  WriteChar(SysScreen,75,1,58) ;
  WriteChar(SysScreen,74,1,CMOS_GetByte(4) AND $0F+48) ;
  WriteChar(SysScreen,73,1,(CMOS_GetByte(4) AND $F0) SHR 4 +48) ;
END ;

PROCEDURE IDT0 ;  ASSEMBLER ;
ASM
  PUSHA
    CLI
    MOV DX,24
    MOV DS,DX
    INC WORD PTR DS:[OFFSET TimeTicks]
    CALL UpdateTime ;
    CALL DoPICReset ;
  POPA
  STI
END ;

PROCEDURE WaitKB ;
BEGIN
  WHILE (PORT[$64] AND $2>0) DO ;
END ;

PROCEDURE UpdateScreen ;
VAR x,y : WORD ;
    scrn  : WORD ;
BEGIN
  scrn:=136+ (MEM[128:768] SHL 3) ;
  FOR x:=0 TO 79 DO
    FOR y:=0 TO 24 DO
      ShowChar(x*9,y*9,MEM[scrn:x*2+y*160]) ;
END ;

PROCEDURE OutP60 ;
BEGIN
  WaitKB ;
  PORT[$64]:=$AD ;
  WaitKB ;
  INC(MEM[128:0]) ;
  MEM[128:MEM[128:0]]:=PORT[$60] ;
  IF (MEM[128:MEM[128:0]]>=59) AND (MEM[128:MEM[128:0]]<=67) THEN BEGIN
    {IF STyp=0 THEN }SetLogicalScreen(MEM[128:MEM[128:0]]-59) ;
    {IF STyp>0 THEN }BEGIN
      MEM[128:768]:=MEM[128:MEM[128:0]]-59 ;
      UpdateScreen ;
    END ;
    DEC(MEM[128:0]) ;
  END ELSE IF MEM[128:MEM[128:0]]=68 THEN BEGIN { Screen 9 (F10) heisst jetzt reboot }
    { Do reboot on Scroll-Lock }
    ASM
      LIDT [0]
      INT 0
    END ;
    SetGDTEntry(8,0,0,0,0,0) ;                  { Code Segment sperren }
    SetGDTEntry(2,0,0,0,0,0) ;                  { Wie, programm luft noch ? }
    SetGDTEntry(1,0,0,0,0,0) ;                  { dann auch GDT und IDT sperren }
    ASM
      HLT                                       { sptestens jetzt sollte ein Trible-Fault ausgelst worden sein }
    END ;
  END ELSE BEGIN
    IF MEM[128:MEM[128:0]] And $80>0 THEN
      DEC(MEM[128:0]) ;
  END ;
  WaitKB ;
  PORT[$64]:=$AE ;
  DOPICReset ;
END ;

PROCEDURE IDT1 ; ASSEMBLER ;
ASM
  PUSHF
  CLI
  PUSHA
  MOV DX,64
  MOV ES,DX
  CALL OutP60
  POPA
  POPF
  STI
END ;

PROCEDURE IDT1c ; ASSEMBLER ;
ASM
  PUSHA
  MOV DX,64
  MOV ES,DX
  MOV BYTE PTR ES:[3200],33
  POPA
END ;

PROCEDURE IDT2 ; INTERRUPT ;
BEGIN
  MEM[64:0]:=ORD('2') ;
END ;

PROCEDURE IDT3 ; INTERRUPT ;
BEGIN
  MEM[64:0]:=ORD('3') ;
END ;

PROCEDURE IDT4 ; INTERRUPT ;
BEGIN
  MEM[64:0]:=ORD('4') ;
END ;

PROCEDURE IDT5 ; INTERRUPT ;
BEGIN
  MEM[64:0]:=ORD('5') ;
END ;

PROCEDURE IDT6 ; INTERRUPT ;
BEGIN
  MEM[64:0]:=ORD('6') ;
END ;

PROCEDURE IDT7 ; INTERRUPT ;
BEGIN
  MEM[64:0]:=ORD('7') ;
END ;

PROCEDURE IDT8 ; INTERRUPT ;
BEGIN
  MEM[64:0]:=ORD('8') ;
END ;

PROCEDURE IDT9 ; INTERRUPT ;
BEGIN
  MEM[64:0]:=ORD('9') ;
END ;

PROCEDURE IDTA ; INTERRUPT ;
BEGIN
  MEM[64:0]:=ORD('A') ;
END ;

PROCEDURE IDTB ; INTERRUPT ;
BEGIN
  MEM[64:0]:=ORD('B') ;
END ;

PROCEDURE IDTC ; INTERRUPT ;
BEGIN
  MEM[64:0]:=ORD('C') ;
END ;

PROCEDURE IDTD ; INTERRUPT ; ASSEMBLER ;
ASM
  PUSHA
  MOV DX,64
  MOV DS,DX
  MOV BYTE PTR DS:[0],'>'
  MOV BYTE PTR DS:[1],$17
  MOV BYTE PTR DS:[2],'>'
  MOV BYTE PTR DS:[3],$17
  MOV BYTE PTR DS:[4],'>'
  MOV BYTE PTR DS:[5],$17
  MOV BYTE PTR DS:[6],'G'
  MOV BYTE PTR DS:[7],$17
  MOV BYTE PTR DS:[8],'e'
  MOV BYTE PTR DS:[9],$17
  MOV BYTE PTR DS:[10],'n'
  MOV BYTE PTR DS:[11],$17
  MOV BYTE PTR DS:[12],'e'
  MOV BYTE PTR DS:[13],$17
  MOV BYTE PTR DS:[14],'r'
  MOV BYTE PTR DS:[15],$17
  MOV BYTE PTR DS:[16],'a'
  MOV BYTE PTR DS:[17],$17
  MOV BYTE PTR DS:[18],'l'
  MOV BYTE PTR DS:[19],$17
  MOV BYTE PTR DS:[20],' '
  MOV BYTE PTR DS:[21],$17
  MOV BYTE PTR DS:[22],'P'
  MOV BYTE PTR DS:[23],$17
  MOV BYTE PTR DS:[24],'r'
  MOV BYTE PTR DS:[25],$17
  MOV BYTE PTR DS:[26],'o'
  MOV BYTE PTR DS:[27],$17
  MOV BYTE PTR DS:[28],'t'
  MOV BYTE PTR DS:[29],$17
  MOV BYTE PTR DS:[30],'e'
  MOV BYTE PTR DS:[31],$17
  MOV BYTE PTR DS:[32],'c'
  MOV BYTE PTR DS:[33],$17
  MOV BYTE PTR DS:[34],'t'
  MOV BYTE PTR DS:[35],$17
  MOV BYTE PTR DS:[36],'i'
  MOV BYTE PTR DS:[37],$17
  MOV BYTE PTR DS:[38],'o'
  MOV BYTE PTR DS:[39],$17
  MOV BYTE PTR DS:[40],'n'
  MOV BYTE PTR DS:[41],$17
  MOV BYTE PTR DS:[42],'f'
  MOV BYTE PTR DS:[43],$17
  MOV BYTE PTR DS:[44],'a'
  MOV BYTE PTR DS:[45],$17
  MOV BYTE PTR DS:[46],'u'
  MOV BYTE PTR DS:[47],$17
  MOV BYTE PTR DS:[48],'l'
  MOV BYTE PTR DS:[49],$17
  MOV BYTE PTR DS:[50],'t'
  MOV BYTE PTR DS:[51],$17
  MOV BYTE PTR DS:[52],'<'
  MOV BYTE PTR DS:[53],$17
  MOV BYTE PTR DS:[54],'<'
  MOV BYTE PTR DS:[55],$17
  MOV BYTE PTR DS:[56],'<'
  MOV BYTE PTR DS:[57],$17
  POPA
END ;

PROCEDURE IDTE ; INTERRUPT ;
BEGIN
  MEM[64:0]:=ORD('E') ;
  PORT[$20]:=$20 ;
END ;
