PROGRAM LoadSys ;

USES Crt ;

CONST
  SysScreen     = 0 ;

VAR
  STyp        : WORD ;                                  { Screen-Typ (runtime) 0=Text/1=Grafik }

{$I MMPRE.INC}                                          { Vordefinition zum Memory-Management }
{$I Texte.inc}                                          { Definiere STRINGS }
{$I IRQ.INC}                                            { PIC-Proceduren }
{$I CPU_STAT.INC}                                       { CPU-Infos }
{$I BEEP.INC}                                           { Speaker-Proceduren }
{$I U_SCREEN.INC}                                       { Funktionen zum Bildzugriff (unter VESA/CRT) }
{$I DRV_DEF.INC}                                        { Laufwerksdefinition }
{$I HD.INC}                                             { HD-Hardwareschnittstelle }
{$I HD_ENH.INC}                                         { Erweiterte HD-Befehle (mit Strukturcontext) }
{$I FS_MAN.INC}
{$I PARTPRE.INC}
{$I FS_FAT.INC}
{$I PART.INC}
{$I PCI.dev}                                            { PCI-Gruppen }
{$I PCI.INC}                                            { PCI-Hardwareschnittstelle }
{$I A20GATE.INC}                                        { Freischaltung der geraden Megs (20te-Adressline) }
{$I IDT15.INC}                                          { Interrupt-Services }
{$I TTY.INC}                                            { Keyboard-Kontrolle }
{$I DRV_MAN.INC}                                        { Laufwerksverwaltung }
{$I MManager.pas}                                       { Memory-Manager / pm-Switcher }

BEGIN
  ClrScr ;                                              { Lsche Bildschirm fr Meldungen }
  InitTexte ;                                           { Lade STRINGS (Puffer ist im PMode micht verfgbar) }
  WriteLn('Lade System...') ;
  WriteLn('Getting CPU-Typ ...') ;
  IF NOT Check386 THEN BEGIN                            { Ist 386 ?}
    WriteLn('Getting CPU-Typ ... not an 386 or above') ;
    WriteLn('Press a key to exit boot') ;
    ReadKey ;
    Halt ;
  END ;
  IF NOT TestVM86 THEN BEGIN                            { Im V86-Mode ? }
    WriteLn('CPU-Typ = ',GetCPUID) ;                    { Melde CPU-Typ }
  END ;
  IF TestVM86 THEN BEGIN
    WriteLn('Not able to switch to protected-mode') ;
    ReadKey ;
    Halt ;
  END ;
  WriteLn('Initialisiere Memory-Management') ;
  ClrScr ;
  StartProtectedMode ;                                  { Springe in den Protected-Mode }
END.