PROCEDURE EnableIRQ(nr : BYTE) ;
BEGIN
  IF nr<8 THEN BEGIN                                    { Low INT }
    PORT[$21]:=PORT[$21] AND NOT (1 SHL nr) ;           { PIC1-enable line NR }
  END ELSE BEGIN                                        { High INT }
    EnableIRQ(2) ;                                      { PIC1 enable PIC2 }
    PORT[$A1]:=PORT[$A1] AND NOT (1 SHL (nr-8)) ;       { PIC2 enable line NR }
  END ;
END ;

PROCEDURE DisableIRQ(nr : BYTE) ;
BEGIN
  IF nr<8 THEN BEGIN                                    { Low INT }
    PORT[$21]:=PORT[$21] OR (1 SHL nr) ;                { PIC1 disable line NR }
  END ELSE BEGIN                                        { High INT }
    PORT[$A1]:=PORT[$A1] OR (1 SHL (nr-8)) ;            { PIC2 disable line NR }
    IF PORT[$A1]=$FF THEN DisableIRQ(2) ;               { IF none active line on PIC2 then disable line 2 of PIC1 }
  END ;
END ;