{ Include File for Memory-Management im Protected Mode }

CONST GDT_Size      = 29 ;
      IDT_Size      = 32 ;
      Code_Deskript = 48 ;
      Screen        = 64 ;
      TestSegment   = 72 ;
      MemAllocSeg   = 80 ;
      ASegment      = 88 ;
      Segment0      = 96 ;
      FSegment      = 104 ;
      TaskSegment   = 112 ;

TYPE Deskriptor = RECORD
                    Limit     : WORD ;
                    Base_Low  : WORD ;
                    Base_High : BYTE ;
                    Access    : BYTE ;
                    reserved  : WORD ;
                  END ;
     tTablePtr  =RECORD
                    Size : WORD ;
                    BASE : LONGINT ;
                  END ;
     tCHAR      = ARRAY[0..256] OF CHAR ;

VAR
    MemMax      : WORD ;
    ScreenSeg   : WORD ;
    startg      : BYTE ;
    GDT         : POINTER ;
    IDT         : POINTER ;
    MaxMem      : WORD ;
    LastGDT     : WORD ;

    GDTTable    : ARRAY[0..100] OF Deskriptor ;
    IDTTable    : ARRAY[0..100] OF Deskriptor ;
    GDTTablePTR : tTablePtr ;
    IDTTablePTR : tTablePtr ;

PROCEDURE SetByte(val,desk,o1,o2 : WORD) ; ASSEMBLER ;
ASM
  MOV AX,desk
  MOV ES,AX
  MOV DI,o1
  DB 66h
   SHL DI,16
  MOV DI,o2
  MOV AX,val
  DB 67h
   STOSB
END ;

FUNCTION GetByte(desk,o1,o2 : WORD) : WORD ;
VAR tmp : WORD ;
BEGIN
 ASM
  PUSH DS
  MOV AX,desk
  MOV DS,AX
  MOV SI,o1
  DB 66h
   SHL SI,16
  MOV SI,o2
  DB 67h
   LODSB
  POP DS
  MOV tmp,AX
 END ;
 GetByte:=tmp ;
END ;

PROCEDURE SetGDTEntry(idx,Limit,BLow,BHigh,Access,Res : WORD) ;
BEGIN
  GDTTable[idx].Limit:=Limit ;
  GDTTable[idx].Base_Low:=BLow ;
  GDTTable[idx].Base_High:=BHigh ;
  GDTTable[idx].Access:=Access ;
  GDTTable[idx].Reserved:=Res ;
END ;

PROCEDURE ReserveKB(Mpos,kPos : WORD) ;
VAR b,idx : WORD ;
BEGIN
  b:=Mpos SHL 7 + (kPos AND $F8) SHR 3 ;
  idx:=kPos AND $07 ;
  MEM[30*8:b]:=MEM[30*8:b] OR (1 SHL idx) ;
END ;

PROCEDURE ReleaseKB(Mpos,kpos : WORD) ;
VAR b,idx : WORD ;
BEGIN
  b:=Mpos SHL 7 + (kPos AND $F8) SHR 3 ;
  idx:=kPos AND $07 ;
  MEM[30*8:b]:=MEM[30*8:b] AND NOT (1 SHL idx) ;
END ;

FUNCTION AvailKB(mpos,kpos : WORD) : BOOLEAN ;
VAR b,idx : WORD ;
BEGIN
  b:=Mpos SHL 7 + (kPos AND $F8) SHR 3 ;
  idx:=kPos AND $07 ;
  AvailKB:=(MEM[30*8:b] AND (1 SHL idx) = 0) ;
END ;

(*
FUNCTION FindFreeBlock(size : WORD) : LONGINT ;
VAR i : LONGINT ;
    ablk : WORD ;
BEGIN
  ablk:=0 ;
  FOR i:=0 TO LONGINT(MemMax SHL 10) DO BEGIN
    IF AvailKB(i) THEN INC(ablk)
                  ELSE ablk:=0 ;
    IF ablk=size THEN BEGIN
      FindFreeBlock:=LONGINT(i) - LONGINT(size-1) ;
      Exit ;
    END ;
  END ;
  FindFreeBlock:=0 ;    { Kein Block gefunden }
END ; *)

FUNCTION FreeMBs : WORD ;
VAR i,q,sz,mb : WORD ;
BEGIN
  sz:=0 ;
  mb:=0 ;
  FOR q:=0 TO MaxMem DO
    FOR i:=0 TO 1023 DO BEGIN
      IF AvailKB(q,i) THEN INC(sz) ;
      IF sz=1024 THEN BEGIN
        INC(MB) ;
        sz:=0 ;
      END ;
    END ;
  FreeMBs:=mb ;
END ;

FUNCTION FreeKBs : WORD ;
VAR i,q,sz,mb : WORD ;
BEGIN
  sz:=0 ;
  mb:=0 ;
  FOR q:=0 TO MaxMem DO
    FOR i:=0 TO 1023 DO BEGIN
      IF AvailKB(q,i) THEN INC(sz) ;
      IF sz=1024 THEN BEGIN
        INC(MB) ;
        sz:=0 ;
      END ;
    END ;
  FreeKBs:=sz ;
END ;

FUNCTION MapPhysMEM(low,high,size : WORD) : WORD ;
BEGIN
  INC(LastGDT) ;
  SetGDTEntry(LastGDT,size,low,high,$92,0) ;
  MapPhysMEM:=LastGDT*8 ;
END ;

PROCEDURE CreateInitialMEMTable ;
VAR i : WORD ;
BEGIN
  SetGDTEntry(30,MemMax * 128,$22,0,$92,0) ;    { Reserve 64Kb-Block 1Byte = 8 KB }
  FOR i:=0 TO MemMax * 128 DO
    MEM[30*8:i]:=0 ;                            { Init with 0=free }
  FOR i:=0 TO 1023 DO
    ReserveKB(0,i) ;                            { Reserve low 1MB }
  FOR i:=0 TO 63 DO
    ReserveKB(1,i) ;                            { Reserve for Desk16 }
  FOR i:=0 TO 40 DO
    ReserveKB(2,i) ;                            { Reserve for Screens }
  FOR i:=0 TO 64 DO
    ReserveKB(3,i) ;                            { Reserve for Desk27/28/29 }
  FOR i:=0 TO 63 DO
    ReserveKB(2,i+512) ;                        { Reserve for this MEM-Table }
  LastGDT:=30 ;
END ;

PROCEDURE TestRam ;                     { Stelle RAM-Bestckung fest }
VAR vorhanden : BOOLEAN ;
    i         : WORD ;
BEGIN
  i:=65535 ;                            { i:=-1 }
  vorhanden:=TRUE ;                     { Speicher ist vorhanden, es sei denn, er ist nicht da }
  MemMax:=1 ;                           { Ich nehme an 1 MB hat jeder }
  WHILE vorhanden DO BEGIN              { Solange der Speicher da ist suche weiter nach Ende }
    i:=i+1 ;                            {   erhhe i }
    SetByte(i+3,88,i SHL 4,0) ;         {   Speicher Wert in MB(i) }
    IF GetByte(88,i SHL 4,0)<>i+3 THEN  {   Kann ich den Wert auch wieder auslesen ? }
      vorhanden:=FALSE                  {     Nein - Ende des Speichers }
    ELSE
      MemMax:=MemMax+1 ;                {   Ansonsten gibt es noch mehr MBs }
  END ;
  MEM[24:OFS(RAMTesttxt[0])+1]:=(MemMax DIV 1000) +48 ;
  MEM[24:OFS(RAMTesttxt[0])+2]:=((MemMax DIV 100) MOD 10) +48 ;
  MEM[24:OFS(RAMTesttxt[0])+3]:=((MemMax DIV 10) MOD 10) +48 ;
  MEM[24:OFS(RAMTesttxt[0])+4]:=(MemMax MOD 10) +48 ;
  MEM[24:OFS(RAMTesttxt[0])+5]:=32 ;
  MEM[24:OFS(RAMTesttxt[0])+6]:=77 ;
  MEM[24:OFS(RAMTesttxt[0])+7]:=66 ;
  MEM[24:OFS(RAMTesttxt[0])+8]:=32 ;
  MEM[24:OFS(RAMTesttxt[0])+9]:=82 ;
  MEM[24:OFS(RAMTesttxt[0])+10]:=65 ;
  MEM[24:OFS(RAMTesttxt[0])+11]:=77 ;
  MEM[24:OFS(RAMTesttxt[0])+0]:=11 ;    { Setze RAMTestTxt mit Gre }
END ;

PROCEDURE Go ;                          { Hier startet der pm-Code }
VAR info : ARRAY[0..255] OF WORD ;
    tmp,scrn  : WORD ;
    i,q       : WORD ;
    tmpprc : PROCEDURE ;
BEGIN
  TimeTicks:=0 ;
  @tmpprc:=PTR(48,Ofs(@IDT1c^)) ;
    FOR tmp:=0 TO $0FFF DO BEGIN        { Lsche alle Bildschirme }
      FOR Scrn:=0 TO 9 DO BEGIN
        MEM[136+Scrn*8:tmp]:=$20 ;      { mit Leerzeichen }
        MEM[136+Scrn*8:tmp+1]:=$E0 ;    { in wei }
      END ;
    END ;
    FOR tmp:=0 TO 9 DO BEGIN
      posx[tmp]:=1 ;
      posy[tmp]:=1 ;
    END ;
    MEM[128:768]:=0 ;                   { Aktuell gezeigter Bildschirm = 0 }
    MEM[128:769]:=0 ;
    TestRAM ;                           { Lade Speichergre }
    CreateInitialMEMTable ;             { Erstelle Speichertabelle }
    CreateIDE_Interface ;
    CreateDriveTable ;                  { Erstelle Laufwerkstabelle }
    LocateDrives ;                      { Lade Laufwerksparameter }
    WriteLine(1,Screen1) ;              { Weise den Screens Namen zu }
    WriteLine(2,Screen2) ;
    WriteLine(3,Screen3) ;
    WriteLine(4,Screen4) ;
    WriteLine(5,Screen5) ;
    WriteLine(6,Screen6) ;
    WriteLine(7,Screen7) ;
    WriteLine(8,Screen8) ;
    WriteLine(9,Screen9) ;
    WriteLine(SysScreen,RamTestTxt) ;       { Gebe RAM auf SysScreen aus }
    WriteLine(SysScreen,TestDrives) ;       { Gebe HD-Laufwerke auf SysScreen aus }
    WriteHex(SysScreen,40,2,LastDrv+1) ;
(*    SetVESAEntry ; *)
    EnableIRQ(1) ;                              { Aktiviere Tastatur }
    EnableIRQ(0) ;                              { Aktiviere Timeticker (8555) }
    WriteLine(SysScreen,EndedBoot) ;       { Melde Bootvorgang beendet }
    ReadPartitions ;
    WriteHex(Sysscreen,1,10,LastPart) ;
    ASM
      STI
      @1: JMP @1
    END ;
  WHILE (1=1) DO ;
END ;

PROCEDURE SetIDT ;
VAR i : INTEGER ;
BEGIN
  FOR i:=0 TO 31 DO
    WITH IDTTable[i] DO BEGIN
      Limit:=OFS(ADDR(IDT1)^) ;
      Base_Low:=48 ;
      Base_High:=0 ;
      Access:=$86 ;
      reserved:=0 ;
    END ;
    WITH IDTTable[16] DO BEGIN
      Limit:=OFS(ADDR(IDT0)^) ;
      Base_Low:=48 ;
      Base_High:=0 ;
      Access:=$86 ;
      reserved:=0 ;
    END ;
    WITH IDTTable[0] DO BEGIN
      Limit:=OFS(ADDR(IDTDIVZ)^) ;
      Base_Low:=48 ;
      Base_High:=0 ;
      Access:=$86 ;
      reserved:=0 ;
    END ;
END ;

VAR
  tmpPrc        : PROCEDURE ;
  i             : WORD ;

PROCEDURE StartProtectedMode ;
VAR s,s2  : WORD ;           { Zwischenspeicher fr ASM-Befehle }
    o,o2  : WORD ;
BEGIN
  STyp:=0 ;             { ScreenTyp = Text }
  ReSetA20 ;            { Bereite Zugriff auf gerade Megs vor }

  HD_MEM_Base:=128 ;    { HD-Speicher festlegen }
  HD_MEM_Idx:=256 ;
  HD_Err:=0 ;           { Laufwerke hatten bis jetzt keine Fehler }

  GDT:=ADDR(GDTTable) ;
  IDT:=ADDR(IDTTable) ;

  SetGDTEntry(0,0,0,0,0,0) ;
  SetGDTEntry(1,100*SizeOf(Deskriptor),
              LONGINT(LONGINT(SEG(GDT^))* LONGINT(16) + LONGINT(OFS(GDT^))) AND $FFFF,
              LONGINT(LONGINT(SEG(GDT^))* LONGINT(16) + LONGINT(OFS(GDT^))) SHR 16,
              $92,0) ;
  SetGDTEntry(2,IDT_Size*SizeOf(Deskriptor),
              LONGINT(LONGINT(SEG(IDT^))* LONGINT(16) + LONGINT(OFS(IDT^))) AND $FFFF,
              LONGINT(LONGINT(SEG(IDT^))* LONGINT(16) + LONGINT(OFS(IDT^))) SHR 16,
              $92,0) ;
  SetGDTEntry(3,$FFFF,
              LONGINT(LONGINT(DSEG)* LONGINT(16) + LONGINT(0)) AND $FFFF,
              LONGINT(LONGINT(DSEG)* LONGINT(16) + LONGINT(0)) SHR 16,
              $92,0) ;
  SetGDTEntry(4,$FFFF,
              LONGINT(LONGINT(DSEG)* LONGINT(16) + LONGINT(0)) AND $FFFF,
              LONGINT(LONGINT(DSEG)* LONGINT(16) + LONGINT(0)) SHR 16,
              $92,0) ;
  SetGDTEntry(5,$FFFF,
              LONGINT(LONGINT(SSEG)* LONGINT(16) + LONGINT(0)) AND $FFFF,
              LONGINT(LONGINT(SSEG)* LONGINT(16) + LONGINT(0)) SHR 16,
              $92,0) ;
  SetGDTEntry(6,$FFFF,
              LONGINT(LONGINT(CSEG)* LONGINT(16) + LONGINT(0)) AND $FFFF,
              LONGINT(LONGINT(CSEG)* LONGINT(16) + LONGINT(0)) SHR 16,
              $9A,0) ;
  SetGDTEntry(7,0,0,0,0,0) ;
  SetGDTEntry(8,$FFFF,
              LONGINT(LONGINT($B800)* LONGINT(16) + LONGINT(0)) AND $FFFF,
              LONGINT(LONGINT($B800)* LONGINT(16) + LONGINT(0)) SHR 16,
              $92,0) ;
  SetGDTEntry(9,$FFFF,0,0,$92,$D080) ;
  SetGDTEntry(10,$FFFF,0,$0A,$92,$80) ;
  SetGDTEntry(11,$FFFF,0,$10,$92,$80) ;
  SetGDTEntry(12,$FFFF,
              LONGINT(LONGINT(SEG(IDT0))* LONGINT(16) + LONGINT(OFS(IDT0))) AND $FFFF,
              LONGINT(LONGINT(SEG(IDT0))* LONGINT(16) + LONGINT(OFS(IDT0))) SHR 16,
              $9A,0) ;
  SetGDTEntry(13,$FFFF,
              LONGINT(LONGINT($F000)* LONGINT(16) + LONGINT(0)) AND $FFFF,
              LONGINT(LONGINT($F000)* LONGINT(16) + LONGINT(0)) SHR 16,
              $92,$80) ;
  SetGDTEntry(14,100*SizeOf(Deskriptor),
              LONGINT(LONGINT(SEG(GDT^))* LONGINT(16) + LONGINT(OFS(GDT^))) AND $FFFF,
              LONGINT(LONGINT(SEG(GDT^))* LONGINT(16) + LONGINT(OFS(GDT^))) SHR 16,
              $92,0) ;
  SetGDTEntry(15,$FFFF,0,0,$9A,0) ;
  SetGDTEntry(16,$FFFF,0,$10,$92,0) ;
  SetGDTEntry(17,$2000,0,$20,$92,0) ;
  SetGDTEntry(18,$2000,$2000,$20,$92,0) ;
  SetGDTEntry(19,$2000,$4000,$20,$92,0) ;
  SetGDTEntry(20,$2000,$6000,$20,$92,0) ;
  SetGDTEntry(21,$2000,$8000,$20,$92,0) ;
  SetGDTEntry(22,$2000,$A000,$20,$92,0) ;
  SetGDTEntry(23,$2000,$C000,$20,$92,0) ;
  SetGDTEntry(24,$2000,$E000,$20,$92,0) ;
  SetGDTEntry(25,$2000,0,$21,$92,0) ;
  SetGDTEntry(26,$2000,$2000,$21,$92,0) ;
  SetGDTEntry(27,$FFFF,0,$30,$92,0) ;
  SetGDTEntry(28,$FFFF,0,$30,$92,0) ;
  SetGDTEntry(29,$20,0,$31,$92,0) ;
  FOR i:=30 TO 99 DO
    SetGDTEntry(i,0,0,0,0,0) ;

  GDTTablePtr.Size:=800 ;
  GDTTablePtr.Base:=LONGINT(LONGINT(OFS(GDTTable[0].Limit)) + LONGINT(SEG(GDTTable) SHL 4)) ;

  IDTTablePtr.Size:=IDT_Size*8 ;
  IDTTablePtr.Base:=LONGINT(LONGINT(OFS(IDTTable[0].Limit)) + LONGINT(SEG(IDTTable) SHL 4)) ;

  SetIDT ;                               { Setze Zugriff auf Interrupt-Routinen }

  s:=Seg(GDTTable) ;
  s2:=Seg(IDTTablePtr) ;
  o2:=Ofs(IDTTablePtr) ;
  PORT[$A1]:=$FF ;                      { Deaktiviere alle Interrupts }
  PORT[$21]:=$FF ;
  ASM
    CLI

    MOV AH,$89
    MOV BX,$1018
    MOV SI,s
    MOV ES,SI
    MOV SI,OFFSET GDTTable ;
    INT $15                     { Umschalten zum pm }

    MOV DX,24
    MOV DS,DX                   { Set ES and DS with pm-Segments }
    MOV ES,DX
    MOV DX,40
    MOV SS,DX

    CALL Go                     { Starte pm-Routinen }
    HLT
  END ;
  WriteLn('Error switching into protected-mode') ;
END ;
