PROCEDURE WriteLine(screen : BYTE;VAR text : STRING) ; FORWARD ;
PROCEDURE WriteHex(Scrn,x,y : WORD ;val : WORD) ; FORWARD ;
PROCEDURE WriteCHAR(Scrn,x,y : WORD ;b : BYTE) ; FORWARD ;

TYPE tPM_Info   = RECORD
                    ID          : ARRAY[0..3] OF BYTE ;
                    Entry       : WORD ;
                    init        : WORD ;
                    BIOS_Data   : WORD ;
                    A000,B000   : WORD ;
                    B800,C000   : WORD ;
                    PM_Flag     : BYTE ;
                    Checksum    : BYTE ;
                  END ;

VAR
  VESA_Service  : PROCEDURE ;

VAR SS_,SP_ : WORD ;

PROCEDURE INT10(AX_,BX_,CX_,DX_,ES_,DS_,SI_,DI_ : WORD) ;
BEGIN
  ASM
    MOV AX,$4F00
    MOV BX,$100
    CALL Vesa_Service
    MOV DX,24
    MOV DS,DX
  END ;
END ;

PROCEDURE SetVESAEntry ;
VAR PM_Init : PROCEDURE ;
    tmp,tmp2 : ^tPM_Info ;
    b   : BYTE ;
    i,q,entry   : WORD ;
    RET66       : ^WORD ;
BEGIN
  SetGDTEntry(40,$FFFF,$00,$0C,$92,$00) ;
  SetGDTEntry(41,$FFFF,$00,$40,$92,$00) ;
  SetGDTEntry(42,$FFFF,$00,$40,$9A,$00) ;
  FOR i:=0 TO 65535 DO BEGIN
    MEM[41*8:i]:=MEM[40*8:i] ;
  END ;
  FOR i:=0 TO 65515 DO BEGIN
    tmp2:=PTR(41*8,i) ;
    IF (tmp2^.id[0]=80) AND
       (tmp2^.id[1]=77) AND
       (tmp2^.id[2]=73) AND
       (tmp2^.id[3]=68) THEN BEGIN
      tmp:=PTR(41*8,i) ;
      Entry:=i ;
      i:=65515 ;
    END ;
  END ;
  b:=0 ;
  FOR i:=0 to 19 DO
    b:=b+MEM[41*8:i+OFS(tmp^)] ;
  IF b<>0 THEN BEGIN
    WriteLine(SysScreen,VESAErr) ;
  END ELSE BEGIN
    SetGDTEntry(43,$FFFF,$00,$41,$92,0) ;
    FOR i:=0 TO $FFFF DO
      MEM[43*8:i]:=0 ;
    tmp^.Bios_Data:=43*8 ;
    SetGDTEntry(44,$FFFF,$00,$0A,$92,0) ;
    SetGDTEntry(45,$FFFF,$00,$0B,$92,0) ;
    SetGDTEntry(46,$7FFF,$8000,$0B,$92,0) ;
    tmp^.A000:=44*8 ;
    tmp^.B000:=45*8 ;
    tmp^.B800:=46*8 ;
    tmp^.C000:=41*8 ;
    tmp^.PM_Flag:=1 ;
    @PM_Init:=PTR(42*8,tmp^.Init) ;
    SetGDTEntry(47,$FFFF,$00,$42,$92,0) ;
    MEM[41*8:$8000]:=$66 ;                  { Create 32Bit near-Call in the }
    MEM[41*8:$8001]:=$E8 ;                  { C000-Segment to call to }
    MEM[41*8:$8002]:=tmp^.Init-6 ;          { the Init-Routine }
    MEM[41*8:$8003]:=$80 ;
    MEM[41*8:$8004]:=$FF ;
    MEM[41*8:$8005]:=$FF ;
    MEM[41*8:$8006]:=$CB ;
    MEM[41*8:$8007]:=$66 ;                  { Create 32Bit near-Call in the }
    MEM[41*8:$8008]:=$E8 ;                  { C000-Segment to call to }
    MEM[41*8:$8009]:=tmp^.Entry-$D ;        { the INT10-Routine }
    MEM[41*8:$800A]:=$80 ;
    MEM[41*8:$800B]:=$FF ;
    MEM[41*8:$800C]:=$FF ;
    MEM[41*8:$800D]:=$CB ;
    @PM_Init:=PTR(42*8,$8000) ;
    @VESA_Service:=PTR(42*8,$8007) ;
    PM_Init ;
    ASM
      MOV AX,24
      MOV DS,AX
    END ;
    WriteLine(SysScreen,VESA_RDY) ;
  END ;
END ;

PROCEDURE SetScreen(val1,val2,size1,size2 : WORD) ; ASSEMBLER ;
ASM
  MOV CX,size1
  DB 66h
    SHL CX,16
  MOV CX,size2
  MOV AX,val1
  DB 66h
    SHL AX,16
  MOV AX,val2
  XOR DI,DI
  MOV DX,72
  MOV ES,DX
  DB 66h
    REP
    DB 66h
     DB 67h
      STOSW
END ;

PROCEDURE SetScreenLONG(v1,v2,pos1,pos2 : WORD) ; ASSEMBLER ;
ASM
  MOV AX,v1
  DB 66h
    SHL AX,16
  MOV AX,v2
  MOV DI,pos1
  DB 66h
    SHL DI,16
  MOV DI,pos2
  MOV DX,72
  MOV ES,DX
  DB 66h
   DB 67h
    STOSW
END ;

PROCEDURE SetScreenLONGS(v1,v2,pos1,pos2,l : WORD) ; ASSEMBLER ;
ASM
  MOV CX,l
  MOV AX,v1
  DB 66h
    SHL AX,16
  MOV AX,v2
  MOV DI,pos1
  DB 66h
    SHL DI,16
  MOV DI,pos2
  MOV DX,72
  MOV ES,DX
  REP
  DB 66h
   DB 67h
    STOSW
END ;

PROCEDURE hLine(x,y,l : WORD ; r,g,b : BYTE) ;
VAR o,s : WORD ;
BEGIN
  ASM
    DB 66h
     XOR AX,AX
    DB 66h
     XOR BX,BX
    MOV AX,y
    MOV BX,640
    DB 66h
     MUL BX
    MOV BX,x
    DB 66h
     ADD AX,BX
    DB 66h
     SHL AX,2
    MOV o,AX
    DB 66h
     SHR AX,16
    MOV s,AX
  END ;
  SetScreenLONGS(r,g SHL 8+b,s,o,l) ;
END ;

PROCEDURE Punkt(x,y : WORD ; r,g,b : BYTE) ;
VAR o,s : WORD ;
BEGIN
  ASM
    DB 66h
     XOR AX,AX
    DB 66h
     XOR BX,BX
    MOV AX,y
    MOV BX,800
    DB 66h
     MUL BX
    MOV BX,x
    DB 66h
     ADD AX,BX
    DB 66h
     SHL AX,2
    MOV o,AX
    DB 66h
     SHR AX,16
    MOV s,AX
  END ;
  SetScreenLONG(r,g SHL 8+b,s,o) ;
END ;


PROCEDURE VLine(x,y,l : WORD ; r,g,b : BYTE) ;
VAR i : WORD ;
BEGIN
  FOR i:=0 TO l DO
    Punkt(x,y+i,r,g,b) ;
END ;

PROCEDURE ShowChar(x,y,ch : WORD) ;
VAR a,b : WORD ;
    o   : WORD ;
BEGIN
  ch:=ch AND $FF ;
  o:=$FA6E + ch * 8 ;
  FOR a:=0 TO 7 DO BEGIN
    FOR b:=0 TO 7 DO BEGIN
      IF MEM[104:o+a] AND (128 SHR b)>0 THEN Punkt(x+b,y+a,255,255,255)
                                        ELSE Punkt(x+b,y+a,0,0,0) ;
    END ;
  END ;
END ;
VAR
   posx,posy    : ARRAY[0..9] OF BYTE ;

PROCEDURE WriteText(Scrn,x,y : WORD ;VAR txt : STRING) ;
VAR ZielSeg : WORD ;
    i       : WORD ;
BEGIN
  ZielSeg:=136 + Scrn SHL 3 ;
  IF (Scrn=MEM[128:768]) THEN ZielSeg:=64 ;
  FOR i:=1 TO MEM[24:OFS(txt[0])] DO BEGIN
    MEM[ZielSeg:(x+i-2)*2  +  (y-1) * 160]:=MEM[24:OFS(txt[0])+i] ;
  END ;
END ;

PROCEDURE WriteCHAR(Scrn,x,y : WORD ;b : BYTE) ;
VAR ZielSeg : WORD ;
    i       : WORD ;
BEGIN
  ZielSeg:=136 + Scrn SHL 3 ;
  IF (Scrn=MEM[128:768]) THEN ZielSeg:=64 ;
  MEM[ZielSeg:(x-1)*2  +  (y-1) * 160]:=b ;
END ;

PROCEDURE WriteHex(Scrn,x,y : WORD ;val : WORD) ;
VAR ZielSeg : WORD ;
    i       : WORD ;
BEGIN
  ZielSeg:=136 + Scrn SHL 3 ;
  IF Scrn=MEM[128:768] THEN ZielSeg:=64 ;
  FOR i:=1 TO 4 DO BEGIN
    IF VAL AND $0F<10 THEN BEGIN
      MEM[ZielSeg:(x+(4-i)-1)*2  +  (y-1) * 160]
        :=(VAL AND $0F)+48 ;
    END
    ELSE BEGIN
      MEM[ZielSeg:(x+(4-i)-1)*2  +  (y-1) * 160]
        :=(VAL AND $0F)+55 ;
    END ;
    val:=val SHR 4 ;
  END ;
END ;

PROCEDURE WriteDez(Scrn,x,y : WORD ;val : WORD) ;
VAR ZielSeg : WORD ;
    i       : WORD ;
BEGIN
  ZielSeg:=136 + Scrn SHL 3 ;
  IF Scrn=MEM[128:768] THEN ZielSeg:=64 ;
  FOR i:=1 TO 5 DO BEGIN
    MEM[ZielSeg:(x+(5-i)-1)*2  +  (y-1) * 160]
      :=(VAL MOD 10) + 48 ;
    val:=val DIV 10 ;
  END ;
END ;

PROCEDURE WriteLine(screen : BYTE;VAR text : STRING) ;
BEGIN
  WriteText(screen,posx[screen],posy[Screen],text) ;
  INC(posy[screen]) ;
  posx[screen]:=1 ;
END ;

FUNCTION NullText(VAR text : STRING) : BOOLEAN ;
BEGIN
  NullText:=(MEM[24:OFS(text[0])]=0) ;
END ;

PROCEDURE Spacer(screen,len : BYTE) ;
BEGIN
  INC(PosX[Screen],len) ;
  PosY[screen]:=Posy[screen]+(Posx[screen] DIV 80) ;
  PosX[screen]:=Posx[screen] MOD 80 ;
END ;